SystemOrganization addCategory: #'GMF-MetaModel'!

Object subclass: #Attribute
	instanceVariableNames: 'name dataType quantity instance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-MetaModel'!

!Attribute class methodsFor: 'instance creation' stamp: 'Anonymous 4/5/2013 10:30'!
name: newName dataType: newDataType quantity: newQuantity

	^(super new initialize)
		name: newName;
		dataType: newDataType;
		quantity: newQuantity;
		yourself! !

!Attribute class methodsFor: 'instance creation' stamp: 'volosmat 5/10/2013 09:42'!
name: newName dataType: newDataType quantity: newQuantity instance: newInstance

	^(super new initialize)
		name: newName;
		dataType: newDataType;
		quantity: newQuantity;
		instance: newInstance;
		yourself! !

!Attribute methodsFor: 'accessing' stamp: 'Anonymous 4/5/2013 10:28'!
dataType
	^ dataType! !

!Attribute methodsFor: 'accessing' stamp: 'Anonymous 4/5/2013 10:28'!
dataType: anObject
	dataType := anObject! !

!Attribute methodsFor: 'initialize-release' stamp: 'volosmat 7/16/2013 21:49'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."

	super initialize.
	" *** Edit the following to properly initialize instance variables ***"
	instance := true.
	" *** And replace this comment with additional initialization code *** "
	^self! !

!Attribute methodsFor: 'accessing' stamp: 'volosmat 7/16/2013 21:49'!
instance
	^ instance! !

!Attribute methodsFor: 'accessing' stamp: 'volosmat 7/16/2013 21:49'!
instance: anObject
	instance := anObject! !

!Attribute methodsFor: 'accessing' stamp: 'Anonymous 4/5/2013 10:29'!
name
	^ name! !

!Attribute methodsFor: 'accessing' stamp: 'Anonymous 4/5/2013 10:28'!
name: anObject
	name := anObject! !

!Attribute methodsFor: 'accessing' stamp: 'Anonymous 4/5/2013 10:28'!
quantity
	^ quantity! !

!Attribute methodsFor: 'accessing' stamp: 'Anonymous 4/5/2013 10:28'!
quantity: anObject
	quantity := anObject! !

Object subclass: #ElementAssociation
	instanceVariableNames: 'start startQuantity end endQuantity name transformed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-MetaModel'!

ElementAssociation subclass: #DirectedBinaryAssociation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-MetaModel'!

DirectedBinaryAssociation subclass: #DependencyRelationship
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-MetaModel'!

DependencyRelationship subclass: #Characterization
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-MetaModel'!

DependencyRelationship subclass: #Derivation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-MetaModel'!

DependencyRelationship subclass: #Mediation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-MetaModel'!

DirectedBinaryAssociation subclass: #Meronymic
	instanceVariableNames: 'isEssential isInseparable isImmutablePart isImmutableWhole'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-MetaModel'!

Meronymic subclass: #ComponentOf
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-MetaModel'!

Meronymic subclass: #MemberOf
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-MetaModel'!

!Meronymic methodsFor: 'initialize-release' stamp: 'Anonymous 4/5/2013 11:53'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."

	super initialize.
	" *** Edit the following to properly initialize instance variables ***"
	isEssential := False.
	isImmutablePart := False.
	isImmutableWhole := False.
	isInseparable := False.
	" *** And replace this comment with additional initialization code *** "
	^self! !

!Meronymic methodsFor: 'accessing' stamp: 'Anonymous 4/5/2013 11:51'!
isEssential
	^ isEssential! !

!Meronymic methodsFor: 'accessing' stamp: 'Anonymous 4/5/2013 11:51'!
isEssential: anObject
	isEssential := anObject! !

!Meronymic methodsFor: 'accessing' stamp: 'Anonymous 4/5/2013 11:51'!
isImmutablePart
	^ isImmutablePart! !

!Meronymic methodsFor: 'accessing' stamp: 'Anonymous 4/5/2013 11:51'!
isImmutablePart: anObject
	isImmutablePart := anObject! !

!Meronymic methodsFor: 'accessing' stamp: 'Anonymous 4/5/2013 11:51'!
isImmutableWhole
	^ isImmutableWhole! !

!Meronymic methodsFor: 'accessing' stamp: 'Anonymous 4/5/2013 11:51'!
isImmutableWhole: anObject
	isImmutableWhole := anObject! !

!Meronymic methodsFor: 'accessing' stamp: 'Anonymous 4/5/2013 11:51'!
isInseparable
	^ isInseparable! !

!Meronymic methodsFor: 'accessing' stamp: 'Anonymous 4/5/2013 11:51'!
isInseparable: anObject
	isInseparable := anObject! !

Meronymic subclass: #SubCollectionOf
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-MetaModel'!

Meronymic subclass: #SubQuantityOf
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-MetaModel'!

!ElementAssociation class methodsFor: 'instance creation' stamp: 'Anonymous 5/6/2013 17:17'!
name: newName start: newStart end: newEnd
	^(super new initialize)
		name: newName;
		start: newStart;
		end: newEnd;
		yourself! !

!ElementAssociation class methodsFor: 'instance creation' stamp: 'Anonymous 4/5/2013 11:33'!
name: newName start: newStart startQuantity: newStartQuantity end: newEnd endQuantity: newEndQuantity
	^(super new initialize)
		name: newName;
		start: newStart;
		startQuantity: newStartQuantity;
		end: newEnd;
		endQuantity: newEndQuantity;
		yourself! !

!ElementAssociation methodsFor: 'accessing' stamp: 'Anonymous 4/5/2013 11:30'!
end
	^ end! !

!ElementAssociation methodsFor: 'accessing' stamp: 'Anonymous 4/5/2013 11:30'!
end: anObject
	end := anObject! !

!ElementAssociation methodsFor: 'accessing' stamp: 'Anonymous 4/5/2013 11:30'!
endQuantity
	^ endQuantity! !

!ElementAssociation methodsFor: 'accessing' stamp: 'Anonymous 4/5/2013 11:30'!
endQuantity: anObject
	endQuantity := anObject! !

!ElementAssociation methodsFor: 'initialize-release' stamp: 'volosmat 7/19/2013 12:59'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."

	super initialize.
	" *** Edit the following to properly initialize instance variables ***"
	transformed := false.
	^self! !

!ElementAssociation methodsFor: 'method' stamp: 'volosmat 12/17/2013 23:38'!
isClass
	^false! !

!ElementAssociation methodsFor: 'accessing' stamp: 'Anonymous 4/5/2013 11:36'!
name
	^ name! !

!ElementAssociation methodsFor: 'accessing' stamp: 'Anonymous 4/5/2013 11:36'!
name: anObject
	name := anObject! !

!ElementAssociation methodsFor: 'accessing' stamp: 'Anonymous 4/5/2013 11:30'!
start
	^ start! !

!ElementAssociation methodsFor: 'accessing' stamp: 'Anonymous 4/5/2013 11:30'!
start: anObject
	start := anObject! !

!ElementAssociation methodsFor: 'accessing' stamp: 'Anonymous 4/5/2013 11:30'!
startQuantity
	^ startQuantity! !

!ElementAssociation methodsFor: 'accessing' stamp: 'Anonymous 4/5/2013 11:30'!
startQuantity: anObject
	startQuantity := anObject! !

!ElementAssociation methodsFor: 'accessing' stamp: 'volosmat 7/19/2013 12:59'!
transformed
	^ transformed! !

!ElementAssociation methodsFor: 'accessing' stamp: 'volosmat 7/19/2013 12:59'!
transformed: anObject
	transformed := anObject! !

ElementAssociation subclass: #FormalAssociation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-MetaModel'!

ElementAssociation subclass: #MaterialAssociation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-MetaModel'!

Object subclass: #ElementClass
	instanceVariableNames: 'methods comment associations name parent transformed abstract disjoint attributes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-MetaModel'!

!ElementClass class methodsFor: 'instance creation' stamp: 'Anonymous 4/4/2013 10:37'!
name: newName

^(super new initialize)
name: newName;
yourself! !

!ElementClass methodsFor: 'accessing' stamp: 'volosmat 7/16/2013 14:19'!
abstract
	^abstract! !

!ElementClass methodsFor: 'accessing' stamp: 'volosmat 7/16/2013 14:14'!
abstract: anObject
	abstract := anObject! !

!ElementClass methodsFor: 'accessing' stamp: 'Anonymous 4/2/2013 23:17'!
associations
	^ associations! !

!ElementClass methodsFor: 'accessing' stamp: 'Anonymous 4/2/2013 23:17'!
associations: anObject
	associations := anObject! !

!ElementClass methodsFor: 'accessing' stamp: 'volosmat 12/11/2013 23:57'!
attributes
	^ attributes! !

!ElementClass methodsFor: 'accessing' stamp: 'volosmat 12/11/2013 23:58'!
attributes: anObject
	attributes := anObject.
	
	attributes ifNil: [ attributes := OrderedCollection new ]! !

!ElementClass methodsFor: 'accessing' stamp: 'volosmat 7/16/2013 14:19'!
disjoint
	^disjoint! !

!ElementClass methodsFor: 'accessing' stamp: 'volosmat 7/16/2013 14:14'!
disjoint: anObject
	disjoint := anObject! !

!ElementClass methodsFor: 'initialize-release' stamp: 'volosmat 12/11/2013 22:10'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."

	super initialize.
	" *** Edit the following to properly initialize instance variables ***"
	name := nil.
	attributes := OrderedCollection new.
	methods := OrderedCollection new.
	associations := OrderedCollection new.
	comment := nil.
	parent := OrderedCollection new.
	transformed := false.
	abstract := false.
	disjoint := OrderedCollection new.
	" *** And replace this comment with additional initialization code *** "
	^self! !

!ElementClass methodsFor: 'methods' stamp: 'volosmat 12/17/2013 23:38'!
isClass
	^true! !

!ElementClass methodsFor: 'accessing' stamp: 'Anonymous 4/2/2013 23:18'!
methods
	^ methods! !

!ElementClass methodsFor: 'accessing' stamp: 'volosmat 11/27/2013 14:11'!
methods: anObject
	methods := anObject.
	
	methods ifNil: [ methods := OrderedCollection new ]! !

!ElementClass methodsFor: 'accessing' stamp: 'Anonymous 4/4/2013 10:42'!
name
	^ name! !

!ElementClass methodsFor: 'accessing' stamp: 'Anonymous 4/4/2013 10:42'!
name: anObject
	name := anObject! !

!ElementClass methodsFor: 'accessing' stamp: 'Anonymous 4/8/2013 09:14'!
parent
	^ parent! !

!ElementClass methodsFor: 'accessing' stamp: 'volosmat 11/28/2013 18:32'!
parent: anObject
	parent add: anObject.
	disjoint add: true.! !

!ElementClass methodsFor: 'accessing' stamp: 'volosmat 11/28/2013 18:32'!
parent: anObject disjoint: xDisjoint
	parent add: anObject.
	disjoint add: xDisjoint.
	! !

!ElementClass methodsFor: 'methods' stamp: 'volosmat 12/12/2013 00:40'!
removeAssociation: xName
	associations := associations reject: [ :each | each name = xName ]! !

!ElementClass methodsFor: 'methods' stamp: 'volosmat 12/11/2013 22:11'!
removeAttribute: xName
	attributes := attributes reject: [ :each | each name = xName ]! !

!ElementClass methodsFor: 'methods' stamp: 'volosmat 11/27/2013 17:53'!
removeMethod: xName
	methods := methods reject: [ :each | each name = xName ]! !

!ElementClass methodsFor: 'search' stamp: 'volosmat 12/17/2013 18:00'!
searchAssociation: xName 
	^ associations detect: [ :each | each name = xName ].! !

!ElementClass methodsFor: 'search' stamp: 'volosmat 12/11/2013 22:11'!
searchAttribute: xName 
	^ attributes detect: [ :each | each name = xName ].! !

!ElementClass methodsFor: 'search' stamp: 'volosmat 11/27/2013 01:03'!
searchMethod: xName 
	^ methods detect: [ :each | each name = xName ].! !

!ElementClass methodsFor: 'accessing' stamp: 'volosmat 7/16/2013 14:20'!
transformed
	^transformed! !

!ElementClass methodsFor: 'accessing' stamp: 'volosmat 7/16/2013 14:14'!
transformed: anObject
	transformed := anObject! !

!ElementClass methodsFor: 'methods' stamp: 'MatusVolosin 10/27/2013 19:30'!
validateClass

	^true! !

!ElementClass methodsFor: 'methods' stamp: 'MatusVolosin 10/27/2013 19:31'!
validateClassName
	| allowed |
	
	allowed := ($0 to: $9), {$_}, ($A to: $Z), ($a to: $z).
	(name detect: [:c | (allowed includes: c) not] ifNone: [ ])
		ifNotNil: [ ^ false].
	name first canBeGlobalVarInitial ifFalse:[^false].
	^ true! !

ElementClass subclass: #MomentClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-MetaModel'!

MomentClass subclass: #Mode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-MetaModel'!

!Mode methodsFor: 'methods' stamp: 'MatusVolosin 10/27/2013 19:30'!
validateClass

   | checkMode |
      "mode podobne ako quality musi byt napojeny na koniec characterizacnej relace"
	associations do: [ :b | ( ( b end class = Mode ) & ( b class = Characterization  ) ) ifTrue: [ checkMode := true. ] ].
	"mode nemoze mat ako nadtyp kind subkind role a phase"
	parent do: [ :a | ( ( a class = Kind ) | 
					  ( a class = SubKind ) | 
     					  ( a class = Role ) |
	  				  ( a class = Phase ) ) ifTrue: [  checkMode := nil ]. ].
	
	   ( checkMode notNil )
            ifTrue: [ ^true ];
            ifFalse: [^false ].! !

MomentClass subclass: #Quality
	instanceVariableNames: 'asAttribute'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-MetaModel'!

!Quality methodsFor: 'accessing' stamp: 'Anonymous 4/8/2013 09:51'!
asAttribute
	^ asAttribute! !

!Quality methodsFor: 'accessing' stamp: 'Anonymous 4/8/2013 09:51'!
asAttribute: anObject
	asAttribute := anObject! !

!Quality methodsFor: 'initialize-release' stamp: 'Anonymous 4/8/2013 09:51'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."

	super initialize.
	" *** Edit the following to properly initialize instance variables ***"
	asAttribute := False.
	" *** And replace this comment with additional initialization code *** "
	^self! !

!Quality methodsFor: 'methods' stamp: 'MatusVolosin 10/27/2013 19:30'!
validateClass

   | checkQuality |
      "qualita podobne ano mode musi byt napojeny na koniec characterizacnej relace"
	associations do: [ :b | ( ( b end class = Quality ) & ( b class = Characterization  ) ) ifTrue: [ checkQuality := true. ] ].
	"qualita nemoze mat ako nadtyp kind subkind role a phase"
	parent do: [ :a | ( ( a class = Kind ) | 
					  ( a class = SubKind ) | 
     					  ( a class = Role ) |
	  				  ( a class = Phase ) ) ifTrue: [ checkQuality := nil ]. ].
	
	   ( checkQuality notNil )
            ifTrue: [ ^true ];
            ifFalse: [^false ].! !

MomentClass subclass: #Relator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-MetaModel'!

!Relator methodsFor: 'methods' stamp: 'MatusVolosin 10/27/2013 19:30'!
validateClass

   | relAssociation |
    
	associations do: [ :b | ( ( b end class = Relator ) & ( b class = Mediation  ) ) ifTrue: [ relAssociation := b end ] ].
	
	parent do: [ :a | ( ( a class = Kind ) | 
					  ( a class = SubKind ) | 
     					  ( a class = Role ) |
	  				  ( a class = Phase ) ) ifTrue: [  relAssociation := nil ]. ].
	
	   ( relAssociation notNil )
            ifTrue: [ ^true ];
            ifFalse: [^false ].! !

ElementClass subclass: #ObjectClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-MetaModel'!

ObjectClass subclass: #MixinClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-MetaModel'!

MixinClass subclass: #NonRigidMixinClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-MetaModel'!

NonRigidMixinClass subclass: #AntiRigidMixinClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-MetaModel'!

AntiRigidMixinClass subclass: #RoleMixin
	instanceVariableNames: 'roles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-MetaModel'!

!RoleMixin methodsFor: 'initialize-release' stamp: 'Anonymous 5/7/2013 14:06'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."

	super initialize.
	" *** Edit the following to properly initialize instance variables ***"
	roles := Set new.
	" *** And replace this comment with additional initialization code *** "
	^self! !

!RoleMixin methodsFor: 'accessing' stamp: 'Anonymous 5/7/2013 14:04'!
roles
	^ roles! !

!RoleMixin methodsFor: 'accessing' stamp: 'Anonymous 5/7/2013 14:04'!
roles: anObject
	roles := anObject! !

!RoleMixin methodsFor: 'methods' stamp: 'MatusVolosin 10/27/2013 19:30'!
validateClass

   | checkRoleMix |
    "rolemixin ma pod sebov aspon 1 role"
    roles do: [:b | checkRoleMix := true ].
    "rolemixin nemoze mat ako nadtyp kind subkind role phase"
	parent do: [ :a | ( ( a class = Kind ) | 
					  ( a class = SubKind ) | 
     					  ( a class = Role ) |
	  				  ( a class = Phase ) ) ifTrue: [ checkRoleMix := nil ]. ].
	
	   ( checkRoleMix notNil )
            ifTrue: [ ^true ];
            ifFalse: [^false ].! !

NonRigidMixinClass subclass: #SemiRigidMixinClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-MetaModel'!

SemiRigidMixinClass subclass: #Mixin
	instanceVariableNames: 'mixObjects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-MetaModel'!

!Mixin methodsFor: 'initialize-release' stamp: 'Anonymous 5/7/2013 17:03'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."

	super initialize.
	" *** Edit the following to properly initialize instance variables ***"
	mixObjects := Set new.
	" *** And replace this comment with additional initialization code *** "
	^self! !

!Mixin methodsFor: 'accessing' stamp: 'Anonymous 5/7/2013 17:03'!
mixObjects
	^ mixObjects! !

!Mixin methodsFor: 'accessing' stamp: 'Anonymous 5/7/2013 17:03'!
mixObjects: anObject
	mixObjects := anObject! !

!Mixin methodsFor: 'methods' stamp: 'MatusVolosin 10/27/2013 19:30'!
validateClass

   | rigidObject nonRigidObject |
      "mixin potrebuje mat pod sebov jeden rigidny a jeden nonrigidny object"
       rigidObject  := mixObjects detect: [:b |  ( ( b class = Kind ) | ( b class = SubKind ) ) ].
       nonRigidObject := mixObjects detect: [:b |  ( ( b class = Phase ) | ( b class = Role ) ) ].

  ( ( rigidObject = nil ) | ( nonRigidObject = nil ) ) ifTrue: [ ^false ].
"nemoze byt pod kind subkind role phase rolemixin"
	parent do: [ :a | ( ( a class = Kind ) | 
					  ( a class = SubKind ) | 
     					  ( a class = Role ) |
	  				  ( a class = Phase ) | 
					  ( a class = RoleMixin ) ) ifTrue: [ ^false ]. ].

	  ^true.! !

MixinClass subclass: #RigidMixinClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-MetaModel'!

RigidMixinClass subclass: #Category
	instanceVariableNames: 'subObjects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-MetaModel'!

!Category methodsFor: 'initialize-release' stamp: 'Anonymous 5/7/2013 10:55'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."

	super initialize.
	" *** Edit the following to properly initialize instance variables ***"
	subObjects := Set new.
	" *** And replace this comment with additional initialization code *** "
	^self! !

!Category methodsFor: 'accessing' stamp: 'Anonymous 5/7/2013 10:54'!
subObjects
	^ subObjects! !

!Category methodsFor: 'accessing' stamp: 'Anonymous 5/7/2013 10:54'!
subObjects: anObject
	subObjects := anObject! !

!Category methodsFor: 'methods' stamp: 'MatusVolosin 10/27/2013 19:30'!
validateClass

   | checkCategory |
     "category musi byt nadtypom aspon jedneho objektu typicky kindu"
     subObjects do: [:b | checkCategory  := 1 ].
     "category nesmie mat ako nadtyp kind subkind role phase rolemixin"
	parent do: [ :a | ( ( a class = Kind ) | 
					  ( a class = SubKind ) | 
     					  ( a class = Role ) |
	  				  ( a class = Phase ) ) ifTrue: [ checkCategory := nil ]. ].
		
	   ( checkCategory  notNil )
            ifTrue: [ ^true ];
            ifFalse: [^false ].! !

ObjectClass subclass: #SortalClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-MetaModel'!

SortalClass subclass: #AntiRigidSortalClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-MetaModel'!

AntiRigidSortalClass subclass: #Phase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-MetaModel'!

!Phase methodsFor: 'methods' stamp: 'MatusVolosin 10/27/2013 19:30'!
validateClass

	parent do: [ :a | ( ( a class = Kind ) | 
					  ( a class = SubKind ) | 
     					  ( a class = Collective ) |
	  				  ( a class = Phase ) |
    				        ( a class = Role ) | 
	 				  ( a class = Quantity ) ) ifTrue: [ ^true ]. ].
	
        ^false.
	
	
	
	
! !

AntiRigidSortalClass subclass: #Role
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-MetaModel'!

!Role methodsFor: 'methods' stamp: 'MatusVolosin 10/27/2013 19:30'!
validateClass

	parent do: [ :a | ( ( a class = Kind ) | 
					  ( a class = SubKind ) | 
     					  ( a class = Collective ) |
	  				  ( a class = Phase ) |
    				        ( a class = Role ) | 
	 				  ( a class = Quantity ) ) ifTrue: [ ^true ]. ].
	
        ^false.
     
! !

SortalClass subclass: #RigidSortalClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-MetaModel'!

RigidSortalClass subclass: #SubKind
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-MetaModel'!

!SubKind methodsFor: 'methods' stamp: 'MatusVolosin 10/27/2013 19:30'!
validateClass
     "subkind dedi od kind ak subkind dedi od subkind overim este ostatne subkindy ci su spravne"
	parent do: [:a | 
		( a class = Kind ) ifTrue: [ ^true ].
		( a class = SubKind ) ifTrue: [ ^(a validateClass) ]. ].

     ^false.! !

RigidSortalClass subclass: #SubstanceSortal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-MetaModel'!

SubstanceSortal subclass: #Collective
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-MetaModel'!

!Collective methodsFor: 'methods' stamp: 'MatusVolosin 10/27/2013 19:30'!
validateClass
     
	parent do: [ :a |  ( ( a class = Phase ) | ( a class = Role ) ) ifTrue: [ ^false ]. ].
    ^true.! !

SubstanceSortal subclass: #Kind
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-MetaModel'!

!Kind methodsFor: 'methods' stamp: 'MatusVolosin 10/27/2013 19:30'!
validateClass
     
     "kind nemoze dedit od phase role subkind a rolemixin"
	parent do: [ :a | ( ( a class = RoleMixin ) | 
					  ( a class = SubKind ) | 
     					  ( a class = Role ) |
	  				  ( a class = Phase ) ) ifTrue: [ ^false ]. ].
 
	^ true.! !

SubstanceSortal subclass: #Quantity
	instanceVariableNames: 'isExtensional'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-MetaModel'!

!Quantity methodsFor: 'initialize-release' stamp: 'Anonymous 5/7/2013 18:29'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."

	super initialize.
	" *** Edit the following to properly initialize instance variables ***"
	isExtensional := true.
	" *** And replace this comment with additional initialization code *** "
	^self! !

!Quantity methodsFor: 'accessing' stamp: 'Anonymous 5/7/2013 18:28'!
isExtensional
	^ isExtensional! !

!Quantity methodsFor: 'accessing' stamp: 'Anonymous 5/7/2013 18:28'!
isExtensional: anObject
	isExtensional := anObject! !

!Quantity methodsFor: 'methods' stamp: 'MatusVolosin 10/27/2013 19:30'!
validateClass
     
     parent do: [ :a |  ( ( a class = Phase ) | ( a class = Role ) ) ifTrue: [ ^false ]. ].
    ^true.! !

Object subclass: #MetaModel
	instanceVariableNames: 'modelElements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-MetaModel'!

!MetaModel methodsFor: 'methods' stamp: 'volosmat 5/10/2013 11:33'!
addElement: xElement
	modelElements add: xElement.! !

!MetaModel methodsFor: 'initialize-release' stamp: 'volosmat 5/10/2013 11:28'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."

	super initialize.
	" *** Edit the following to properly initialize instance variables ***"
	modelElements := OrderedCollection new.
	" *** And replace this comment with additional initialization code *** "
	^self! !

!MetaModel methodsFor: 'accessing' stamp: 'volosmat 10/28/2013 22:09'!
modelElements
	^ modelElements copy! !

!MetaModel methodsFor: 'accessing' stamp: 'volosmat 5/10/2013 11:27'!
modelElements: anObject
	modelElements := anObject! !

!MetaModel methodsFor: 'methods' stamp: 'volosmat 5/10/2013 11:35'!
removeElement: xElement
	modelElements := modelElements reject:[ :b | b name = xElement name.]! !

Object subclass: #Method
	instanceVariableNames: 'name returnDataType parameters abstract instance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-MetaModel'!

!Method class methodsFor: 'instance creation' stamp: 'Anonymous 4/5/2013 10:28'!
name: newName

   ^(super new initialize)
      name: newName;
      yourself! !

!Method class methodsFor: 'instance creation' stamp: 'volosmat 7/16/2013 14:08'!
name: xName abstract: xAbstract

   ^(super new initialize)
      name: xName;
	abstract: xAbstract;
      yourself! !

!Method class methodsFor: 'instance creation' stamp: 'volosmat 7/16/2013 14:08'!
name: xName abstract: xAbstract instance: xInstance

   ^(super new initialize)
      name: xName;
	abstract: xAbstract;
	instance: xInstance;
      yourself! !

!Method class methodsFor: 'instance creation' stamp: 'volosmat 7/16/2013 14:09'!
name: xName instance: xInstance

   ^(super new initialize)
      name: xName;
	instance: xInstance;
      yourself! !

!Method class methodsFor: 'instance creation' stamp: 'volosmat 7/16/2013 14:09'!
name: xName returnDataType: xReturnDataType

   ^(super new initialize)
      name: xName;
      returnDataType: xReturnDataType;
      yourself! !

!Method class methodsFor: 'instance creation' stamp: 'volosmat 7/16/2013 14:10'!
name: xName returnDataType: xReturnDataType abstract: xAbstract

   ^(super new initialize)
      name: xName;
      returnDataType: xReturnDataType;
	abstract: xAbstract;
      yourself! !

!Method class methodsFor: 'instance creation' stamp: 'volosmat 7/16/2013 14:10'!
name: xName returnDataType: xReturnDataType abstract: xAbstract instance: xInstance

   ^(super new initialize)
      name: xName;
      returnDataType: xReturnDataType;
	abstract: xAbstract;
	instance: xInstance;
      yourself! !

!Method class methodsFor: 'instance creation' stamp: 'volosmat 11/27/2013 19:43'!
name: xName returnDataType: xReturnDataType abstract: xAbstract instance: xInstance parameters: xParameters

   ^(super new initialize)
      name: xName;
      returnDataType: xReturnDataType;
	abstract: xAbstract;
	instance: xInstance;
	parameters: xParameters;
      yourself! !

!Method class methodsFor: 'instance creation' stamp: 'volosmat 7/16/2013 14:11'!
name: xName returnDataType: xReturnDataType instance: xInstance

   ^(super new initialize)
      name: xName;
      returnDataType: xReturnDataType;
	instance: xInstance;
      yourself! !

!Method methodsFor: 'accessing' stamp: 'volosmat 7/16/2013 14:18'!
abstract
	^abstract! !

!Method methodsFor: 'accessing' stamp: 'volosmat 7/16/2013 14:04'!
abstract: anObject
	abstract := anObject! !

!Method methodsFor: 'initialize-release' stamp: 'volosmat 11/27/2013 19:18'!
initialize
	super initialize.
	name := nil.
	parameters := OrderedCollection new.
	returnDataType := nil.
	abstract := false.
	instance := true.

	^self! !

!Method methodsFor: 'accessing' stamp: 'volosmat 7/16/2013 14:18'!
instance
	^ instance! !

!Method methodsFor: 'accessing' stamp: 'volosmat 7/16/2013 14:04'!
instance: anObject
	instance := anObject! !

!Method methodsFor: 'accessing' stamp: 'Anonymous 4/5/2013 10:25'!
name
	^ name! !

!Method methodsFor: 'accessing' stamp: 'Anonymous 4/5/2013 10:25'!
name: anObject
	name := anObject! !

!Method methodsFor: 'accessing' stamp: 'Anonymous 4/5/2013 10:25'!
parameters
	^ parameters! !

!Method methodsFor: 'accessing' stamp: 'Anonymous 4/5/2013 10:25'!
parameters: anObject
	parameters := anObject! !

!Method methodsFor: 'accessing' stamp: 'Anonymous 4/5/2013 10:25'!
returnDataType
	^ returnDataType! !

!Method methodsFor: 'accessing' stamp: 'Anonymous 4/5/2013 10:25'!
returnDataType: anObject
	returnDataType := anObject! !
